



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>WinForm 中 comboBox控件之数据绑定</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">WinForm 中 comboBox控件之数据绑定</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 02:24:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一、IList</p>
<p>现在我们直接创建一个List集合，然后绑定</p>
<div>
<div>
<pre class="prettyprint linenums">1 IList&lt;string&gt; list = new List&lt;string&gt;();<br />
2 list.Add("111111");<br />
3 list.Add("222222");<br />
4 list.Add("333333");<br />
5 list.Add("444444");<br />
6 comboBox1.DataSource = list;</pre>
</div>
</div>
<p>执行后，我们会发现绑定成功，但是&nbsp;我们知道一般对于下拉框的绑定都会有一个值，一个显示的内容，这个时候我们可以创建一个类，把value和text都封装到这个类，作为list的类型</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">public class Info<br />
    {<br />
        public string Id { get; set; }<br />
        public string Name { get; set; }

    }<br />
      private void bindCbox()<br />
        {<br />
            IList&lt;Info&gt; infoList = new List&lt;Info&gt;();<br />
            Info info1 = new Info() { Id="1",Name="张三"};<br />
            Info info2 = new Info() { Id="2",Name="李四"};<br />
            Info info3 = new Info() { Id = "3",Name = "王五" };<br />
            infoList.Add(info1);<br />
            infoList.Add(info2);<br />
            infoList.Add(info3);<br />
            comboBox1.DataSource = infoList;<br />
            comboBox1.ValueMember = "Id";<br />
            comboBox1.DisplayMember = "Name";<br />
        }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>二、Dictionary</p>
<p>这个有点特殊，不能直接绑定，需要借助类BindingSource才可以完成绑定</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">Dictionary&lt;int, string&gt; kvDictonary = new Dictionary&lt;int, string&gt;();<br />
kvDictonary.Add(1, "11111");<br />
kvDictonary.Add(2, "22222");<br />
kvDictonary.Add(3, "333333");

BindingSource bs = new BindingSource();<br />
bs.DataSource = kvDictonary;<br />
comboBox1.DataSource = bs;<br />
comboBox1.ValueMember = "Key";<br />
comboBox1.DisplayMember = "Value";</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>三、数据集</p>
<p>这个比较常见，很简单</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">//数据集绑定<br />
        private void BindCombox()<br />
        {<br />
            DataTable dt = new DataTable();<br />
            DataColumn dc1 = new DataColumn("id");<br />
            DataColumn dc2 = new DataColumn("name");<br />
            dt.Columns.Add(dc1);<br />
            dt.Columns.Add(dc2);

            DataRow dr1 = dt.NewRow();<br />
            dr1["id"] = "1";<br />
            dr1["name"] = "aaaaaa";

            DataRow dr2 = dt.NewRow();<br />
            dr2["id"] = "2";<br />
            dr2["name"] = "bbbbbb";

            dt.Rows.Add(dr1);<br />
            dt.Rows.Add(dr2);

            comboBox1.DataSource = dt;<br />
            comboBox1.ValueMember = "id";<br />
            comboBox1.DisplayMember = "name";<br />
        }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>注意：</p>
<p>当我们触发combox的SelectedIndexChanged的事件后，我们在加载窗体的时候就会执行，这点我刚开始也和魅惑，导致容易出错，这点我们可以采取一些方法避免执行，比如可以定义一个变量fig=false</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)<br />
   {<br />
       if(this.fig)<br />
       {<br />
           string selectValue = this.cmbAddMember.SelectedValue.ToString();

           rtbaddMember.SelectedText = selectValue;<br />
       }<br />
   }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>那么肯定想在加载窗体后，执行了，所以在加载窗体后我们还要把fig的值设为true</p>
<div>
<pre class="prettyprint linenums">   private void SetAutoMessage_Load(object sender, EventArgs e)<br />
        {<br />
            loadCombox();<br />
            loadMessageTemplet();<br />
            fig= true;<br />
        }</pre>
</div>
<p><strong>获取combox的值方法：&nbsp;</strong></p>
<p><strong>selectvalue 获取value值</strong></p>
<p><strong>selectItem 获取当前内容</strong></p>
<p><strong>selectIndex 获取当前索引</strong></p>
<p><strong>combox.Text 获取当前内容</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdwd7x9.html">SQL Azure &lpar;14&rpar; 将云端SQL Azure中的数据库备份到本地SQL Server</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7emre9.html">分享15个优秀的 CSS 解决方案和工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ejrok9.html">每天一个命令ls  2015&sol;4&sol;1</a>
		</li>
						<li><a href="https://www.batexi.com/a/49glwjzq.html">JVM的粗略简述</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0mvx0q.html">php怎么删除文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x3n109.html">java源码研究--List中的set和add方法区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydozkxq.html">ASP&period;NET 学习小记 -- &OpenCurlyDoubleQuote;迷你&rdquo;MVC实现&lpar;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvnypjq.html">Oracle Enterprise Linux 64-bit下安装apache-tomcat-7&period;0&period;53步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v5rdm8.html">showMonth</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mem5noq.html">scanf&lpar;&rpar;常犯错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgkvwm8.html">tensorflow 学习笔记（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/950e46m8.html">Netflix网关zuul&lpar;1&period;x和2&period;x&rpar;全解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/960jeg39.html">js 原型原型链</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv27k7o9.html">Linux常用基本命令&colon;grep-从文件或者管道中筛选匹配的行</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4vj2j9.html">Windows10下pip的配置文件设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj56yvq.html">What is Druid&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emgrlm9.html">tomcat startup&period;brt启动一闪而过</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp7ll79.html">使用dom4j写xml文件&mdash;&mdash;源码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9je2kdg8.html">USB转串口WIN8驱动安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ml0438.html">Windows下查看进程状态&sol;信息</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gew2me8.html">第二章，循环结构，输入输出，clock</a>
			</li>
						<li><a href="https://www.batexi.com/a/950o4o08.html">&lbrack;笔记&rsqb;JS flat and flatMap</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj4ygx9.html">命令链接按钮QCommandLinkButton</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zowm51q.html">错误：org&period;springframework&period;jdbc&period;support&period;SQLErrorCodesFactory - SQLErrorCodes loaded</a>
			</li>
						<li><a href="https://www.batexi.com/a/9geo1kz8.html">java abs&lpar;绝对值&rpar; &comma; max&lpar;最大值&rpar;&comma;min&lpar;最小值&rpar; 方法的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pvj138.html">VS 测试printf 多参数  输出 i&plus;&plus; 和&plus;&plus;i 结果</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zkm2g9.html">java -jar和hadoop jar的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj3dzr8.html">REM方案总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pvokv8.html">Python自动化中的键盘事件</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ymydw8.html">STM32 的PWM关闭方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
